<?php
/*-----------------------------------------------------
	[SlimBBS ver1.0]
	(c)2008 Tenderfeel
	 http://tenderfeel.xsrv.jp/
	 tenderfeel@gmail.com
	 MIT License
	
	○PHPver4.3以上で動作すると思います。
	　文字コードはUTF-8です。
	
	○削除は直接ログファイルを編集してください。
	
	○投稿フォームはname値が下記のものなら何でもいいです。
	　名前→name　本文→comment　送信ボタン→write
	　送信ボタンをbuttonタグにする場合は
	　heddenでname="write" value="true"とかしてください。
	
	○ログの表示をしたい所に以下の関数を書きます。
	　<?php view_logdata();?>
	
	○過去ログのリンクは以下の関数で表示します。
	　<?php loglink() ?>
	
	○本文は許可タグを指定すればタグ使用可になりますが
	　文法とかは一切チェックしてないので、
	　入力ミスがあった場合は華麗にスルーします。
	
	○日本語を含まない本文が入力された場合は書き込みしません。
	
	○ログファイルが無い場合や、入力エラー等の
	　エラー表示はしない不親切な仕様です。

	○自動挿入される著作権表示はソース内から削除しなければ、
	　CSSで非表示にしても構いません。
	　クラス名はp.copyrightです。

------------------------------------------------------*/
/* 設定 */

//ログファイル名
define('LOGFILE','log.dat');
//表示行数
define('LINEMAX',10);
//保存行数
define('SAVEMAX',200);
//匿名
define('UNKNOWN','名無し');
//文字数制限（しない場合はfalseまたは0)
define('TEXTLIMIT',100);
//許可タグ
$tags = "<b><i>";
/*--------------------------------------------------*/

ini_set("output_buffering", "On");
ini_set("output_handler", "mb_output_handler");
ini_set("default_charset", "UTF-8");
mb_language("Japanese");
mb_internal_encoding ("UTF-8");
mb_http_input("auto");
mb_http_output("UTF-8");
ob_start("mb_output_handler");
define("VERSION","slimbbs ver1.0");

//存在確認
function check_file(){
	if(file_exists(LOGFILE))
		return true;
	else
		return false;
}
//サイズの有無
function check_filesize(){
	if(check_file()==true){
		if(filesize(LOGFILE) == "0") 
			return false;
		else
			return true;
	}else{
		return false;
	}
}
//中身取得
function getContents($flag){
	if(check_filesize()&&check_file()){
		switch($flag){
			case 1 : return file(LOGFILE);
			case 2 : return file_get_contents(LOGFILE);
		}
	}else{
		return false;
	}
}
//Null Byte Attak Killer
function sanitize($arr){
	$ret = str_replace("\0", "", trim($arr));
	if (get_magic_quotes_gpc()) {
		$ret = stripslashes($ret);
	}
	return $ret;
}
//保存
function new_save($data){
	if(check_file()){
		$fp = fopen(LOGFILE, "r+");
		flock($fp, LOCK_EX);
		if(check_filesize(LOGFILE) == true) {
			$contents = getContents(1);
		}
		rewind( $fp );
		fwrite($fp, $data);
		for($i=0;$i < (SAVEMAX-1) ;$i++){
			fwrite($fp, $contents[$i]);
		}
		fclose($fp);
		return true;
	}else{
		return false;
	}
}
//表示用
function formatting($value){
	//$value = mb_convert_encoding($value,"SJIS","UTF-8,EUC-JP,SJIS,auto");
	list($stmp,$name,$comment,$ip,$host)=explode("\t",$value);
	$year =date('Y/', time());
	$date = date('Y/m/d H:i', $stmp);
	$date = strpos($date,$year)!==false ? str_replace($year,"",$date) : $date;
	return "<p><strong>$name</strong>&gt;<span>$comment</span><small>[$date]</small></p>\n";
}
//表示
function view_logdata(){

	if(check_file()&&check_filesize()){
		$logdata = getContents(1);
		if(isset($_GET["mode"])&&$_GET["mode"]=="pastlog"){
			foreach($logdata as $line => $value){
				print formatting($value);
			}
		}else{
			for($i=0;$i<LINEMAX && $i<count($logdata);$i++){
				print formatting($logdata[$i]);
			}
		}
		print "<p class=\"copyright\"><a href=\"http://tenderfeel.xsrv.jp/\">WTN*".VERSION."</a></p>";
	}else{
		print "ログがありません";
	}
}
function loglink(){
	if(isset($_GET["mode"])&&$_GET["mode"]=="pastlog")
		print '<a href="'.basename(__FILE__).'">&laquo; Back</a>';
	else
		print '<a href="'.basename(__FILE__).'?mode=pastlog">Log &raquo;</a>';
}
if(isset($_POST["write"])){

	$err = false;
	
	if(empty($_POST["name"])){
		$postname = UNKNOWN;
	}else{
		$postname = strip_tags(sanitize($_POST["name"]));
	}
	if(empty($_POST["comment"])){
		$err = true;
	}else{
		$postcomment = strip_tags(sanitize($_POST["comment"]),$tags);
		if(preg_match("/^[\x01-\x7e]+$/",$postcomment))
			$err = true;
		
		if(TEXTLIMIT!=false||TEXTLIMIT!=0)
			$postcomment = mb_substr($postcomment,0,TEXTLIMIT);
			$postcomment = str_replace(array("\r\n", "\r", "\n\n","\n"), "", nl2br($postcomment));
	}
	if(empty($err)){
	
		$pastlog = getContents(2);
		$ip = getenv("REMOTE_ADDR");
		$host = gethostbyaddr($ip);
		
		$post = $postname."\t".$postcomment."\t".$ip;
		if(isset($pastlog) && strpos($pastlog,$post)===false){
			$postdata = time()."\t".$post."\t".$host."\n";
			new_save($postdata);
		}
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>SlimBBS</title>
<meta http-equiv="Content-Style-Type" content="text/css" />
<style type="text/css">
<!--
	* {margin:0;padding:0;line-height:1;font-size:13px;font-style:normal;}
	body{font-size:93%;font-family: "ＭＳ Ｐゴシック", Osaka, "ヒラギノ角ゴ Pro W3";background-color:#efefef;}
	div#wrapper {width:400px;margin:50px auto 0 auto;}
	form#post {margin:0 0 10px 0;}
	input#name {width:60px;}
	input#comment {width:250px;}
	input#write {width:40px;}
	p {font-size:93%;line-height:1.4;}
	div#bbslog {border-bottom:solid 1px #666;border-top:solid 1px #666;margin:10px 0 0 0;padding-top:0.5em;}
	div#bbslog p {margin-bottom:0.5em}
	div#bbslog strong {font-weight:normal;padding-right:5px;}
	div#bbslog span {padding:0 5px;}
	div#bbslog small {font-size:85%;}
	p.loglink{text-align:right;padding:3px 0;}
	div#bbslog p.copyright {text-align:center;border-top:solid 1px #ccc;margin:0;}
	div#bbslog p.copyright a {font-size:93%;color:#aaa;text-decoration:none;}
-->
</style>
</head>
<body>
<div id="wrapper">
	<form action="" method="post" id="post">
	<p><label>Name:<input name="name" id="name" type="text" size="10" /></label> <input type="text" name="comment" id="comment" size="40" /><input name="write" value="talk" type="submit" id="write" /></p>
	</form>
	<div id="bbslog">
	<?php view_logdata();?>
	</div>
	<p class="loglink"><?php loglink() ?></p>
</div>
</body>
</html>
